// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcgcrd_spl_4:msg/RCGCRD.idl
// generated code does not contain a copyright notice
#include "rcgcrd_spl_4/msg/detail/rcgcrd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
rcgcrd_spl_4__msg__RCGCRD__init(rcgcrd_spl_4__msg__RCGCRD * msg)
{
  if (!msg) {
    return false;
  }
  // player_num
  msg->player_num = 0;
  // team_num
  msg->team_num = 0;
  // fallen
  msg->fallen = 0;
  // pose
  msg->pose[0] = 0.0f;
  msg->pose[1] = 0.0f;
  msg->pose[2] = 0.0f;
  // ball_age
  msg->ball_age = -1.0f;
  // ball
  msg->ball[0] = 0.0f;
  msg->ball[1] = 0.0f;
  return true;
}

void
rcgcrd_spl_4__msg__RCGCRD__fini(rcgcrd_spl_4__msg__RCGCRD * msg)
{
  if (!msg) {
    return;
  }
  // player_num
  // team_num
  // fallen
  // pose
  // ball_age
  // ball
}

bool
rcgcrd_spl_4__msg__RCGCRD__are_equal(const rcgcrd_spl_4__msg__RCGCRD * lhs, const rcgcrd_spl_4__msg__RCGCRD * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // player_num
  if (lhs->player_num != rhs->player_num) {
    return false;
  }
  // team_num
  if (lhs->team_num != rhs->team_num) {
    return false;
  }
  // fallen
  if (lhs->fallen != rhs->fallen) {
    return false;
  }
  // pose
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->pose[i] != rhs->pose[i]) {
      return false;
    }
  }
  // ball_age
  if (lhs->ball_age != rhs->ball_age) {
    return false;
  }
  // ball
  for (size_t i = 0; i < 2; ++i) {
    if (lhs->ball[i] != rhs->ball[i]) {
      return false;
    }
  }
  return true;
}

bool
rcgcrd_spl_4__msg__RCGCRD__copy(
  const rcgcrd_spl_4__msg__RCGCRD * input,
  rcgcrd_spl_4__msg__RCGCRD * output)
{
  if (!input || !output) {
    return false;
  }
  // player_num
  output->player_num = input->player_num;
  // team_num
  output->team_num = input->team_num;
  // fallen
  output->fallen = input->fallen;
  // pose
  for (size_t i = 0; i < 3; ++i) {
    output->pose[i] = input->pose[i];
  }
  // ball_age
  output->ball_age = input->ball_age;
  // ball
  for (size_t i = 0; i < 2; ++i) {
    output->ball[i] = input->ball[i];
  }
  return true;
}

rcgcrd_spl_4__msg__RCGCRD *
rcgcrd_spl_4__msg__RCGCRD__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcrd_spl_4__msg__RCGCRD * msg = (rcgcrd_spl_4__msg__RCGCRD *)allocator.allocate(sizeof(rcgcrd_spl_4__msg__RCGCRD), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcgcrd_spl_4__msg__RCGCRD));
  bool success = rcgcrd_spl_4__msg__RCGCRD__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcgcrd_spl_4__msg__RCGCRD__destroy(rcgcrd_spl_4__msg__RCGCRD * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcgcrd_spl_4__msg__RCGCRD__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcgcrd_spl_4__msg__RCGCRD__Sequence__init(rcgcrd_spl_4__msg__RCGCRD__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcrd_spl_4__msg__RCGCRD * data = NULL;

  if (size) {
    data = (rcgcrd_spl_4__msg__RCGCRD *)allocator.zero_allocate(size, sizeof(rcgcrd_spl_4__msg__RCGCRD), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcgcrd_spl_4__msg__RCGCRD__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcgcrd_spl_4__msg__RCGCRD__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcgcrd_spl_4__msg__RCGCRD__Sequence__fini(rcgcrd_spl_4__msg__RCGCRD__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcgcrd_spl_4__msg__RCGCRD__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcgcrd_spl_4__msg__RCGCRD__Sequence *
rcgcrd_spl_4__msg__RCGCRD__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcrd_spl_4__msg__RCGCRD__Sequence * array = (rcgcrd_spl_4__msg__RCGCRD__Sequence *)allocator.allocate(sizeof(rcgcrd_spl_4__msg__RCGCRD__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcgcrd_spl_4__msg__RCGCRD__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcgcrd_spl_4__msg__RCGCRD__Sequence__destroy(rcgcrd_spl_4__msg__RCGCRD__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcgcrd_spl_4__msg__RCGCRD__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcgcrd_spl_4__msg__RCGCRD__Sequence__are_equal(const rcgcrd_spl_4__msg__RCGCRD__Sequence * lhs, const rcgcrd_spl_4__msg__RCGCRD__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcgcrd_spl_4__msg__RCGCRD__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcgcrd_spl_4__msg__RCGCRD__Sequence__copy(
  const rcgcrd_spl_4__msg__RCGCRD__Sequence * input,
  rcgcrd_spl_4__msg__RCGCRD__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcgcrd_spl_4__msg__RCGCRD);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcgcrd_spl_4__msg__RCGCRD * data =
      (rcgcrd_spl_4__msg__RCGCRD *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcgcrd_spl_4__msg__RCGCRD__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcgcrd_spl_4__msg__RCGCRD__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcgcrd_spl_4__msg__RCGCRD__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
