// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rcgcrd_spl_4:msg/RCGCRD.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcgcrd_spl_4/msg/rcgcrd.hpp"


#ifndef RCGCRD_SPL_4__MSG__DETAIL__RCGCRD__TRAITS_HPP_
#define RCGCRD_SPL_4__MSG__DETAIL__RCGCRD__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rcgcrd_spl_4/msg/detail/rcgcrd__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rcgcrd_spl_4
{

namespace msg
{

inline void to_flow_style_yaml(
  const RCGCRD & msg,
  std::ostream & out)
{
  out << "{";
  // member: player_num
  {
    out << "player_num: ";
    rosidl_generator_traits::value_to_yaml(msg.player_num, out);
    out << ", ";
  }

  // member: team_num
  {
    out << "team_num: ";
    rosidl_generator_traits::value_to_yaml(msg.team_num, out);
    out << ", ";
  }

  // member: fallen
  {
    out << "fallen: ";
    rosidl_generator_traits::value_to_yaml(msg.fallen, out);
    out << ", ";
  }

  // member: pose
  {
    if (msg.pose.size() == 0) {
      out << "pose: []";
    } else {
      out << "pose: [";
      size_t pending_items = msg.pose.size();
      for (auto item : msg.pose) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: ball_age
  {
    out << "ball_age: ";
    rosidl_generator_traits::value_to_yaml(msg.ball_age, out);
    out << ", ";
  }

  // member: ball
  {
    if (msg.ball.size() == 0) {
      out << "ball: []";
    } else {
      out << "ball: [";
      size_t pending_items = msg.ball.size();
      for (auto item : msg.ball) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RCGCRD & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: player_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "player_num: ";
    rosidl_generator_traits::value_to_yaml(msg.player_num, out);
    out << "\n";
  }

  // member: team_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team_num: ";
    rosidl_generator_traits::value_to_yaml(msg.team_num, out);
    out << "\n";
  }

  // member: fallen
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fallen: ";
    rosidl_generator_traits::value_to_yaml(msg.fallen, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.pose.size() == 0) {
      out << "pose: []\n";
    } else {
      out << "pose:\n";
      for (auto item : msg.pose) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: ball_age
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ball_age: ";
    rosidl_generator_traits::value_to_yaml(msg.ball_age, out);
    out << "\n";
  }

  // member: ball
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ball.size() == 0) {
      out << "ball: []\n";
    } else {
      out << "ball:\n";
      for (auto item : msg.ball) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RCGCRD & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rcgcrd_spl_4

namespace rosidl_generator_traits
{

[[deprecated("use rcgcrd_spl_4::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rcgcrd_spl_4::msg::RCGCRD & msg,
  std::ostream & out, size_t indentation = 0)
{
  rcgcrd_spl_4::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rcgcrd_spl_4::msg::to_yaml() instead")]]
inline std::string to_yaml(const rcgcrd_spl_4::msg::RCGCRD & msg)
{
  return rcgcrd_spl_4::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rcgcrd_spl_4::msg::RCGCRD>()
{
  return "rcgcrd_spl_4::msg::RCGCRD";
}

template<>
inline const char * name<rcgcrd_spl_4::msg::RCGCRD>()
{
  return "rcgcrd_spl_4/msg/RCGCRD";
}

template<>
struct has_fixed_size<rcgcrd_spl_4::msg::RCGCRD>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rcgcrd_spl_4::msg::RCGCRD>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rcgcrd_spl_4::msg::RCGCRD>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RCGCRD_SPL_4__MSG__DETAIL__RCGCRD__TRAITS_HPP_
